package com.arms.api.analysis.cost.controller;

import com.arms.api.analysis.cost.dto.CostDTO;
import com.arms.api.analysis.cost.service.AnalysisCost;
import com.arms.api.analysis.cost.vo.CostVO;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@RestController
@RequestMapping("/engine/analysis-cost")
@Slf4j
@AllArgsConstructor
public class AnalysisCostController {

    private final AnalysisCost analysisCost;

    @PostMapping("/assignee-list")
    public ResponseEntity<List<CostVO>> getAssigneeListByProductVersionAndRequirement(@RequestBody CostDTO costDTO) {

        log.info("AnalysisCostController :: getAssigneeListByProductVersionAndRequirement");

        return ResponseEntity.ok(analysisCost.getAssigneeListByProductVersionAndRequirement(costDTO));

    }

    @PostMapping("/aggregation/assignee-account-id")
    public ResponseEntity<List<CostVO>> aggregationByAssigneeAccountId(@RequestBody CostDTO costDTO) {

        log.info("AnalysisCostController :: aggregationByAssigneeAccountId");

        return ResponseEntity.ok(analysisCost.aggregationByAssigneeAccountId(costDTO));

    }

    @PostMapping("/aggregation/assignee-account-id-and-req-link")
    public ResponseEntity<List<CostVO>> aggregationByReqLinkAndAssigneeAccountId(@RequestBody CostDTO costDTO) {

        log.info("AnalysisCostController :: aggregationByReqLinkAndAssigneeAccountId");

        return ResponseEntity.ok(analysisCost.aggregationByReqLinkAndAssigneeAccountId(costDTO));

    }

}
