package com.arms.api.analysis.requirement.controller;

import com.arms.api.analysis.requirement.dto.ReqAnalysisDTO;
import com.arms.api.analysis.requirement.vo.ReqAndIssueTotalCountVO;
import com.arms.api.analysis.requirement.vo.ReqProgressVO;
import com.arms.api.issue.almapi.model.entity.AlmIssueEntity;
import com.arms.api.util.model.dto.response.*;
import com.arms.api.util.model.dto.request.ALM_이슈_제품_및_버전_집계_요청;
import com.arms.api.util.model.dto.request.ALM_이슈_일별_제품_및_버전_집계_요청;
import com.arms.egovframework.javaservice.esframework.model.vo.버킷_집계_결과_목록_합계;

import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Map;

import com.arms.api.analysis.requirement.service.ReqAnalysisService;

@RestController
@RequestMapping("/engine")
@Slf4j
@AllArgsConstructor
public class ReqAnalysisController {
    //
    // 요구관리, 현황관리, 간트, 칸반에서 사용하는 API 를 넣는다(?)
    //
    private final ReqAnalysisService reqAnalysisService;

    // 대시보드, 디테일_대시보드 -> (( Dashboard Controller 로 이동 필요 ))
    @PostMapping("/jira/dashboard/requirements-jira-issue-statuses")
    public ResponseEntity<Map<String, 요구사항_지라이슈상태_주별_집계>> 요구사항이슈월별집계(
            @RequestBody ALM_이슈_제품_및_버전_집계_요청 지라이슈_제품_및_제품버전_집계_요청
    ) {
        log.info("[요구사항_분석_컨트롤러 :: 요구사항이슈월별집계]");

        return ResponseEntity.ok(reqAnalysisService.요구사항_지라이슈상태_주별_집계(지라이슈_제품_및_제품버전_집계_요청));
    }

    // Top-menu
    @PostMapping("/analysis/top-menu/totalCountWithReqAndSubtask")
    public ResponseEntity<ReqAndIssueTotalCountVO> topMenuTotalCountWithReqAndSubtask(@RequestBody ReqAnalysisDTO reqAnalysisDTO) {

        log.info("[요구사항_분석_컨트롤러 :: 제품별_버전_및_작업자] :: 담당자_목록");

        return ResponseEntity.ok(reqAnalysisService.topMenuTotalCountWithReqAndSubtask(reqAnalysisDTO));
    }

    // Gantt - reqProgress
    @PostMapping("/req-gantt/resolution")
    public ResponseEntity<List<ReqProgressVO>> 일반_버전필터_해결책유무_검색(
            @RequestBody ReqAnalysisDTO reqAnalysisDTO,
            @RequestParam(required = false) String resolution) {

        log.info("[요구사항_분석_컨트롤러 :: 일반_버전필터_해결책유무_검색]");
        // 필요 사항 :: pdServiceLink, pdServiceVersionLinks, resolution, 집계 메인 : cReqLink
        return ResponseEntity.ok(reqAnalysisService.일반_버전필터_해결책유무_검색(reqAnalysisDTO, resolution));
    }

    // Analysis Cost
    @GetMapping("/jira/dashboard/req-updated-list")
    public ResponseEntity<Map<String, List<요구사항_지라이슈키별_업데이트_목록_데이터>>> 요구사항_지라이슈키별_업데이트_목록(@RequestParam List<String> issueList) {

        log.info("요구사항 분석 컨트롤러 :: 요구사항_지라이슈키별_업데이트_목록");

        return ResponseEntity.ok(reqAnalysisService.요구사항_지라이슈키별_업데이트_목록(issueList));
    }

    // Analysis Time
    @PostMapping("/alm-issues/aggregation/by-date")
    public ResponseEntity<버킷_집계_결과_목록_합계> ALM_이슈_일별_제품_버전_집계_조회(
            @RequestBody ALM_이슈_일별_제품_및_버전_집계_요청 ALM_이슈_일별_제품_및_버전_집계_요청) {
        log.info("요구사항 분석 컨트롤러 :: ALM_이슈_기준일별_제품_버전_집계_조회");

        return ResponseEntity.ok(reqAnalysisService.ALM_이슈_일별_제품_버전_집계_조회(ALM_이슈_일별_제품_및_버전_집계_요청));
    }

    // Analysis Time
    @PostMapping("/jira/dashboard/standard-daily/updated-jira-issue")
    public ResponseEntity<List<AlmIssueEntity>>
    기준일자별_제품_및_제품버전목록_업데이트된_이슈조회(
            @RequestBody ALM_이슈_일별_제품_및_버전_집계_요청 ALM_이슈_일별_제품_및_버전_집계_요청) {

        log.info("요구사항 분석 컨트롤러 :: 기준일자별_제품_및_제품버전목록_업데이트된_이슈조회");

        return ResponseEntity.ok(reqAnalysisService.지라이슈_기준일자별_제품_및_제품버전_업데이트된_이슈조회(ALM_이슈_일별_제품_및_버전_집계_요청));
    }

}
