package com.arms.api.dashboard.controller;

import com.arms.api.dashboard.model.vo.AssigneePerVersionVO;
import com.arms.api.dashboard.model.vo.TreeMapWorkerVO;
import com.arms.api.dashboard.model.dto.DashboardAggrDTO;
import com.arms.api.dashboard.model.dto.DashboardDTO;
import com.arms.api.dashboard.model.dto.ResourceWithVersionIdNamesDTO;
import com.arms.api.dashboard.model.vo.Top5ReqAssigneeVO;
import com.arms.api.util.model.dto.request.지라이슈_기본_검색_집계_하위_요청;
import com.arms.egovframework.javaservice.esframework.model.vo.버킷_집계_결과_목록_합계;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import com.arms.api.dashboard.service.Dashboard;

import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("/engine/jira/dashboard")
@Slf4j
@AllArgsConstructor
public class DashboardController {

    private final Dashboard dashboard;


    // Dashboard, Detail_Dashboard
    // 제품별_버전_및_작업자 - 대시보드 Sankey
    @PostMapping(value = "/version-assignees", name="dashboard-findVersionAssignees")
    public ResponseEntity<List<AssigneePerVersionVO>> findVersionAssignees(@RequestBody DashboardDTO dashboardDTO) {
        log.info("[요구사항_분석_컨트롤러 :: 제품별_버전_및_작업자] :: 담당자_목록");

        return ResponseEntity.ok(dashboard.findVersionAssignees(dashboardDTO));
    }


    // Dashboard - TreeMap
    @PostMapping(value="/assignees-requirements-involvements", name="dashboard-treemap")
    public ResponseEntity<List<TreeMapWorkerVO>> 작업자_별_요구사항_별_관여도_treemap(
            @RequestBody ResourceWithVersionIdNamesDTO resourceWithVersionIdNamesDTO
    ) {
        log.info("[지라이슈_대시보드_컨트롤러 :: 작업자_별_요구사항_별_관여도_treemap]");

        return ResponseEntity.ok(dashboard.작업자_별_요구사항_별_관여도_treemap(resourceWithVersionIdNamesDTO));
    }

    @PostMapping("/top5-req-assignee")
    public ResponseEntity<List<Top5ReqAssigneeVO>> Top5ReqAssignee(@RequestBody DashboardAggrDTO dashboardDTO) {

        log.info("[지라이슈_대시보드_컨트롤러 :: Top5ReqAssignee]");

        return ResponseEntity.ok(dashboard.top5ReqAssignee(dashboardDTO));
    }

}
